"{ Package: 'stx:libjava' }"

ProgrammingLanguage subclass:#JavaLanguage
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Support'
!


!JavaLanguage methodsFor:'accessing'!

lookup

    ^Lookup builtin

    "Created: / 17-03-2011 / 14:23:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

name
    "Answers a human-readable name of myself:
     'Smalltalk' for SmalltalkLanguage,
     'Ruby' for RubyLanguage
     ..."

    ^ 'Java'

    "Modified: / 26-10-2010 / 23:40:35 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

sourceFileSuffix
    "Answers a default suffix for source files, i.e. 'st' for Smalltalk, 
     'js' for JavaScript or 'rb' for Ruby', etc."

    ^ 'java'

    "Modified: / 26-10-2010 / 23:40:47 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!JavaLanguage methodsFor:'accessing - classes'!

compilerClass
    "Answer a class suitable for compiling a source code in 'my' language"

    ^ nil "No Java compiler yet"

    "Modified: / 26-10-2010 / 23:41:21 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

lookupClass

    ^JavaLookup

    "Created: / 17-03-2011 / 14:08:17 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

parserClass
    "Answer a class suitable for parsing a source code in 'my' language"

    ^ nil "No Java parser yet"

    "Modified: / 26-10-2010 / 23:41:33 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

sourceFileReaderClass
    "Answers a class that can be used for reading & compiling source files"

    ^ nil "No Java compiler yet"

    "Modified: / 26-10-2010 / 23:41:48 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

sourceFileWriterClass
    "Answers a class is used for source file writing (i.e. file-out)"

    ^ JavaSourceFileWriter

    "Modified: / 27-10-2010 / 18:42:34 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!JavaLanguage methodsFor:'queries'!

supportsExtensionMethods

    ^false

    "Created: / 19-03-2011 / 10:03:13 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!JavaLanguage class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
