"{ Package: 'stx:libjava' }"

AbstractSourceFileWriter subclass:#JavaSourceFileWriter
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Support'
!


!JavaSourceFileWriter methodsFor:'source writing'!

fileOut:class on:stream withTimeStamp:stampIt withInitialize:initIt withDefinition:withDefinition methodFilter:methodFilter encoder:encoderOrNil
    "raise an error: must be redefined in concrete subclass(es)"

    ^ self shouldImplement
!

fileOutMethods:methods on:stream
    "superclass AbstractSourceFileWriter says that I am responsible to implement this method"

    ^ self shouldImplement
!

fileOutPackageDefinition:packageId on:stream
    "Files out a package definition on the stream, so all subsequent
     code entities will be placed in that package"

    ^ self shouldImplement
! !

!JavaSourceFileWriter methodsFor:'source writing - comments'!

fileOutCommentEndOn:aStream
    "
     Writes a comment end mark on aStream."

    ^ aStream nextPutAll: ' */'

    "Modified: / 27-10-2010 / 18:39:49 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

fileOutCommentLine:aString on:aStream
    "superclass AbstractSourceFileWriter says that I am responsible to implement this method"

    ^ aStream nextPutAll: '// '; nextPutAll: aString

    "Modified: / 27-10-2010 / 18:40:48 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

fileOutCommentStartOn:aStream
    "
     Writes a comment end mark on aStream."

    ^ aStream nextPutAll: '/* '

    "Modified: / 27-10-2010 / 18:39:59 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!JavaSourceFileWriter class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
